<?php declare(strict_types=1);

namespace Plugin\css_zubehoer\Migrations;

use JTL\Shop;
use JTL\Jtllog;
use JTL\Plugin\Migration;
use JTL\Update\IMigration;


class Migration20210526123301 extends Migration implements IMigration   {
    /**
     * @inheritdoc
     */

    /*
    define('JTLLOG_LEVEL_EMERGENCY', 600);
    define('JTLLOG_LEVEL_ALERT', 550);
    define('JTLLOG_LEVEL_CRITICAL', 500);
    define('JTLLOG_LEVEL_ERROR', 400);
    define('JTLLOG_LEVEL_WARNING', 300);
    define('JTLLOG_LEVEL_NOTICE', 250);
    define('JTLLOG_LEVEL_INFO', 200);
    define('JTLLOG_LEVEL_DEBUG', 100);
*/

	public function columnExist($table, $field) {
		// false bedeutet das es die Spalte nicht gibt
		return $this->getDB()->query("Show columns from `" . $table . "` like '" . $field . "' ", 1);
	}

	public function tableExist($table) {
		// in Rows steht die Anzahl der Zeilen, false bedeutet das es die Tabelle nicht gibt
		$obj =  $this->getDB()->query("SHOW TABLE STATUS  like '" . $table . "'", 1);
		if($obj && (int) $obj->Rows == 0) {
			$o = $this->getDB()->query("SELECT COUNT(*) AS anzahl FROM " . $table . " WHERE 1",1);
			$obj->Rows = (int) $o->anzahl;
			return $obj;
		}
		return $obj;
	}



	public function JTLWriteLog($cLog='',$nLevel=JTLLOG_LEVEL_INFO ,$bForce=false) {
        if (\mb_strlen($cLog) > 0 && ($bForce || Jtllog::getSytemlogFlag(false))) {
            $logger = Shop::Container()->getLogService();
            $logger = $logger->withName((string) "css_zubehoerConfig");
            $logger->log($nLevel, $cLog, ["css_zubehoerConfig"]);
            return true;
        }
        return false;
    }

    public function up()    {
        $this->execute("
              CREATE TABLE IF NOT EXISTS `css_zubehoerConfig` (
                  `version`  varchar(10) NOT NULL DEFAULT '2.0.0',
                  `sqlupdate` int(10) NOT NULL DEFAULT '0',
                  `framework` char(3) NOT NULL default 'B4',
                  `pluginActive` char(1) NOT NULL default 'N',
                  `css` text NOT NULL,
                  `js` text NOT NULL,
                  `zubehoerPosition` varchar(40) NOT NULL DEFAULT 'before',
                  `zubehoerSelector` varchar(255) NOT NULL DEFAULT '#add-to-cart',
                  `zubehoerSortierung` varchar(10) NOT NULL DEFAULT 'unten',
                  `zubehoerHideXsell` char(1) NOT NULL DEFAULT 'Y',
                  `zubehoerXsellGroup` int(10) NOT NULL DEFAULT '0',
                  `zubehoerImagesize` varchar(40) NOT NULL DEFAULT 'bilder_artikel_klein_breite',
                  `zubehoerBeschreibung` varchar(19) NOT NULL DEFAULT 'short',
                  `bundleBeschreibung` varchar(19) NOT NULL DEFAULT 'short',
                  `bundlePosition` varchar(40) NOT NULL DEFAULT 'after',
                  `bundleSelector` varchar(255) NOT NULL DEFAULT '#buy_form',
                  `bundleHideXsell` char(1) NOT NULL DEFAULT 'Y',
                  `bundleXsellGroup` int(10) NOT NULL DEFAULT '0',
                  `bundleImagesize` varchar(40) NOT NULL DEFAULT 'bilder_artikel_klein_breite',
                  `bundleSelectItems` char(1) NOT NULL DEFAULT 'Y',
                  `buttonModusZubehoer` varchar(20) NOT NULL DEFAULT 'basket',
                  `buttonModusBundle` varchar(20) NOT NULL DEFAULT 'detail'
                  ) ENGINE=InnoDB COLLATE utf8_unicode_ci
        ");


	    if(($obj = $this->tableExist('css_zubehoerConfig')) && $obj->Rows > 0) {
		    $this->execute("UPDATE css_zubehoerConfig set `version` = '2.0.0' ");
	    } else {
		    $this->execute(
			    "INSERT INTO `css_zubehoerConfig` (`version`) VALUES ('2.0.0')"
		    );
	    }

    }

    /**
     * @inheritdoc
     */
    public function down() {
    }
}
